PROGRAM Feigenbaum2;
(* Dieses Programm zeichnet das Feigenbaum-Diagramm fuer die            *)
(* Funktion f(x) = x + cx(1-x), wobei Startwert und Darstellungsbereich *)
(* eingegeben werden!                                                   *)
(* Autor: Dieter Jacob, Mai 1990                                        *)

VAR
   startwert, funktion, constmin, const-max, bereich, constante : REAL;
   zaehler, x, y, drehknopf                                     : INTEGER;
   antwort                                                      : CHAR;
   
# include "graf.p"

PROCEDURE infoausgeben;
BEGIN
   WRITELN("Dieses Programm zeichnet das Feigenbaum-Diagramm     ");
   WRITELN("fuer die Funktion f(x) = x + c * x * (1-x).          ");
   WRITELN("Startwert und Darstellungsbereich werden eingelesen. ");
   WRITELN
END; (* infoausgeben *)

PROCEDURE einlesen;
BEGIN
   WRITELN("Der Startwert liegt zwischen 0 und 1! ");
   WRITE("Gib doch bitte den Startwert ein:       ");
   READLN(startwert);
   WRITELN;
   WRITELN("Der Bereich fuer die Konstante c      ");
   WRITELN("muss im Intervall [0;3] liegen!       ");
   WRITE("Gib doch bitte die untere Grenze ein:   "); READLN(constmin);
   WRITE("Gib doch bitte die obere  Grenze ein:   "); READLN(constmax)
END; (* einlesen *)

PROCEDURE ausgeben;
BEGIN
   WRITELN(" ********** FEIGENBAUM-DIAGRAMM ********** ");
   WRITELN;
   WRITELN("Funktion:  f(x) = x + cx(1-x) ");
   WRITELN("Startwert: ", startwert:4:2);
   WRITELN("Bereich:   ", constmin:5:3, " bis ", constmax:5:3)
END; (* ausgeben *)

PROCEDURE transformieren;
BEGIN
   y := round(50 + funktion / 2 * 650);
   x := round(50 + (constante - constmin) / bereich * 950);
END; (* transformieren *)

BEGIN (*** Hauptprogramm ***)
   infoausgeben;
   WHILE antwort <> "n" DO BEGIN
      einlesen;
      Tek_an;      (*** Grafik-Modus einschalten *************)
      Loeschen;    (*** Bildschirm putzen ********************)
      ausgeben;
      graf;        (*** und in den Punkt-Modus wechseln ******)
      bereich := constmax - constmin;
      FOR drehknopf := 1 TO 180 DO BEGIN
         constante := constmin + bereich / 200 * drehknopf;
         funktion := startwert;
         zaehler := 0;
         WHILE (zaehler <= 70) AND (funktion < 20) DO BEGIN
            funktion := funktion + constante * funktion * (1-funktion);
            zaehler := zaehler + 1;
            transformieren;
            IF zaehler > 50 THEN Punkt(x,y)
         END (* WHILE *);
      END (* FOR *);
      READLN;
      Tek_aus;     (*** Grafik-Modus ausschalten *************)
      WRITELN;
      WRITELN;
      WRITE("Programm wiederholen (j/n)? ");
      READLN(antwort)
   END; (* WHILE *)
END.
